#include "PreprocessorThread.h"
#include "Camera.h"
#include "KdTree.h"
#include "SceneGraph.h"
#include "Preprocessor.h"


namespace GtpVisibilityPreprocessor {


PreprocessorThread::PreprocessorThread(Preprocessor *p):
mPreprocessor(p)
{
}


PreprocessorThread::~PreprocessorThread()
{
}

void
PreprocessorThread::Main()
{
  Camera camera;
  
  if (0)
	{
		// camera.LookAtBox(mPreprocessor->mKdTree->GetBox());
		//	camera.LookInBox(mPreprocessor->mKdTree->GetBox());
		camera.SetPosition(Vector3(3473, 6.778f, -1699.0f));
		camera.SetDirection(Vector3(-0.2432f, 0, 0.97f));
		//	camera.SetPosition(Vector3(991.7, 187.8, -271));
		//	camera.SetDirection(Vector3(0.9, 0, -0.4));

		camera.SnapImage("camera.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
	} 
  
  if (0) {
	camera.LookInBox(mPreprocessor->mKdTree->GetBox());
	camera.SetPosition(camera.mPosition + Vector3(-250,0,-550));
	camera.SnapImage("camera2.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
  }

  if (0) {
	camera.SetPosition( mPreprocessor->mKdTree->GetBox().Center() - Vector3(0,-100,0) );
	camera.SetDirection(Vector3(1, 0, 0));
	camera.SnapImage("camera3.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
  }
  
  if (mPreprocessor->mComputeVisibility) {
	mPreprocessor->ComputeVisibility();
	//	mPreprocessor->ExportPreprocessedData("scene.vis");
	mPreprocessor->PostProcessVisibility();
  }
  
  cerr << "Preprocessor main finished...\n";
  
}


/*PreprocessorThread *PreprocessorThreadFactory::Create(const int threadType)
{
	return NULL;
}*/

}
